unit dand;

{$MODE OBJFPC}{$H+1}

interface

function dand1( const b: Byte; val: LongWord ): LongWord;
function dand2( const b: Byte; val: Word ): Word;
function dand3( const b: Byte; val: LongWord ): LongWord;
function dand4( const b: Byte; val: Word ): Word;
function BranchPath(const BPos: LongWord; const AKey: String): LongWord;
function BranchPathC(const BPos: LongWord; const AKey: String): LongWord;

implementation

function BranchPath(const BPos: LongWord; const AKey: String): LongWord;
begin
  if BPos <= $1F then
  begin
    Result := ( Length( AKey ) shr BPos ) and 1;
  end else
  begin
    Result := ( Ord( AKey[ BPos shr 5 ] ) shr ( BPos and 7 ) ) and 1;
  end;
end;

function BranchPathC(const BPos: LongWord; const AKey: String): LongWord;
begin
  if BPos <= $1F then
  begin
    Result := ( Length( AKey ) shr BPos ) and 1;
  end else
  begin
    Result := ( Ord( AKey[ BPos div 32 ] ) shr ( BPos mod 8 ) ) and 1;
  end;
end;

function dand1( const b: Byte; val: LongWord ): LongWord;
begin
  Result := ( b shr ( val and $7 ) ) and 1;
end;

function dand2( const b: Byte; val: Word ): Word;
begin
  Result := ( b shr ( val and $7 ) ) and 1;
end;

function dand3( const b: Byte; val: LongWord ): LongWord;
begin
  Result := ( b shr ( val mod 8  ) ) and 1;
end;

function dand4( const b: Byte; val: Word ): Word;
begin
  Result := ( b shr ( val mod 8 ) ) and 1;
end;

end.